defmodule Chronoscope.NTS.Behaviour do
  @callback(key_establishment(host :: String.t(), port :: integer()) :: {:ok, Map.t()}, {:error, any()})
end

defmodule Chronoscope.NTS do
  @behaviour Chronoscope.NTS.Behaviour

  require Logger

  alias Chronoscope.NTS.Client

  def healthy?() do
    GenServer.call(Client, :healthy?)
  end

  def list() do
    GenServer.call(Client, :list)
  end

  def key_establishment(host, port) do
    GenServer.call(Client, {:key_establishment, %{host: host, port: port}}, 10_000)
  end
end
